
/*  A Bison parser, made from scan-ops.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse opsparse
#define yylex opslex
#define yyerror opserror
#define yylval opslval
#define yychar opschar
#define yydebug opsdebug
#define yynerrs opsnerrs
#define	VARNAME	257
#define	COMMENT	258
#define	CONSTNAME	259
#define	PREDNAME	260
#define	TYPENAME	261
#define	IMPL	262
#define	PAR	263
#define	PRE	264
#define	EFF	265
#define	ALL	266
#define	DEL	267
#define	ADD	268
#define	NOT	269

#line 1 "scan-ops.y"

#include <stdio.h>
#include <string.h> 
#include "ipp.h"

int act_err;
char *act_err_par;
fact_list act_var, act_const;
effect_list q_goal_list;
inst_effect_list inst_goal_list;
token_list token_ini_facts;
token_list act_goal;
fact_list act_pardec;
fact_list new_neg_pred;

#ifndef SCAN_ERR
#define SCAN_ERR
#define OPNAME_EXPECTED       0
#define PARTOK_EXPECTED       1
#define PARDEC_EXPECTED       2
#define PRETOK_EXPECTED       3
#define PRECONDS_EXPECTED     4
#define EFFTOK_EXPECTED       5
#define EFFECTS_EXPECTED      6
#define TYPENAME_UNKNOWN      7
#endif
static char *errmsg[] = {
  "operator name expected",
  "\':v\' expected",
  "parameter declaration expected",
  "\':p\' expected",
  "list of preconditions expexted",
  "\':e\' expected",
  "list of add & del effects expexted",
  "unknown type '%s' (check for typing errors...)",

  NULL
};

void opserr( int errno, char *par );


#line 48 "scan-ops.y"
typedef union {
  char string[256];
  fact_list fact_list;
  op_list op_list;
  token_list token_list;
  effect_list effect_list;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		60
#define	YYFLAG		-32768
#define	YYNTBASE	20

#define YYTRANSLATE(x) ((unsigned)(x) <= 269 ? yytranslate[x] : 39)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    16,
    17,     2,     2,     2,     2,    18,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    19,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    28,    29,    33,    34,    37,    38,    44,    51,    52,
    55,    58,    66,    72,    73,    76,    77,    80,    82,    85,
    86
};

static const short yyrhs[] = {    21,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    22,     5,    23,     9,    24,    30,    25,    10,    26,    32,
    27,    11,    28,    34,    29,    21,     0,     0,    31,     5,
    30,     0,     0,     3,    31,     0,     0,     6,    16,    33,
    17,    32,     0,    15,     6,    16,    33,    17,    32,     0,
     0,     5,    33,     0,     3,    33,     0,    12,    30,    32,
    38,    35,    36,    37,     0,    32,    38,    35,    36,    37,
     0,     0,    14,    32,     0,     0,    13,    32,     0,    18,
     0,    19,    34,     0,     0,     8,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    94,    97,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   119,   121,   140,   142,   153,   155,   165,   178,   180,
   187,   200,   209,   220,   222,   226,   228,   233,   234,   236,
   237
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","VARNAME",
"COMMENT","CONSTNAME","PREDNAME","TYPENAME","IMPL","PAR","PRE","EFF","ALL","DEL",
"ADD","NOT","'('","')'","'.'","';'","opfile","operator","@1","@2","@3","@4",
"@5","@6","@7","@8","pardec","varlist","factlist","args","effects","addlist",
"dellist","cont","impl", NULL
};
#endif

static const short yyr1[] = {     0,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    21,    30,    30,    31,    31,    32,    32,    32,    33,    33,
    33,    34,    34,    35,    35,    36,    36,    37,    37,    38,
    38
};

static const short yyr2[] = {     0,
     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    16,     0,     3,     0,     2,     0,     5,     6,     0,     2,
     2,     7,     5,     0,     2,     0,     2,     1,     2,     0,
     1
};

static const short yydefact[] = {     2,
     1,     0,     4,     0,     5,    12,    14,     6,     0,    15,
     0,    12,     7,    13,    16,     0,     0,     8,    19,     0,
     0,    19,    19,     0,    19,     9,    21,    20,    16,     0,
    16,    17,    16,    12,    30,    10,    18,    16,    31,    24,
     2,    30,    16,    26,    11,    24,    25,    16,     0,    26,
    27,    28,    16,    23,     0,    29,    22,     0,     0,     0
};

static const short yydefgoto[] = {    58,
     1,     2,     4,     6,    11,    15,    21,    31,    41,     8,
     9,    35,    24,    36,    44,    49,    54,    40
};

static const short yypact[] = {    -1,
-32768,    14,-32768,    11,-32768,     6,    18,-32768,    17,-32768,
    15,     6,-32768,-32768,    -3,    13,    20,-32768,    10,    16,
    19,    10,    10,    21,    10,-32768,-32768,-32768,    -3,    22,
    -5,-32768,    -3,     6,    23,-32768,-32768,    -3,-32768,    26,
    -1,    23,    -3,    24,-32768,    26,-32768,    -3,    -2,    24,
-32768,-32768,    -5,-32768,    -2,-32768,-32768,    27,    34,-32768
};

static const short yypgoto[] = {-32768,
    -6,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -10,
    29,   -15,   -17,   -12,    -4,    -7,   -11,     3
};


#define	YYLAST		45


static const short yytable[] = {    18,
    16,    14,    16,    -3,    27,    28,    34,    30,     7,    17,
   -14,    17,    22,    32,    23,    52,    53,    37,     3,     5,
     7,    12,    42,    38,    13,    20,    59,    47,    19,    26,
    39,    25,    51,    60,    45,    10,    48,    29,    33,    43,
    56,    50,    55,    57,    46
};

static const short yycheck[] = {    15,
     6,    12,     6,     5,    22,    23,    12,    25,     3,    15,
     5,    15,     3,    29,     5,    18,    19,    33,     5,     9,
     3,     5,    38,    34,    10,     6,     0,    43,    16,    11,
     8,    16,    48,     0,    41,     7,    13,    17,    17,    14,
    53,    46,    50,    55,    42
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 94 "scan-ops.y"
{ loaded_ops = yyvsp[0].op_list; ;
    break;}
case 2:
#line 98 "scan-ops.y"
{ yyval.op_list = NULL; ;
    break;}
case 3:
#line 99 "scan-ops.y"
{ opserr( OPNAME_EXPECTED, NULL ); ;
    break;}
case 4:
#line 100 "scan-ops.y"
{ opserr( PARTOK_EXPECTED, NULL ); ;
    break;}
case 5:
#line 101 "scan-ops.y"
{ opserr( PARDEC_EXPECTED, NULL ); ;
    break;}
case 6:
#line 102 "scan-ops.y"
{ opserr( PRETOK_EXPECTED, NULL ); ;
    break;}
case 7:
#line 103 "scan-ops.y"
{ opserr( PRECONDS_EXPECTED, NULL ); ;
    break;}
case 8:
#line 104 "scan-ops.y"
{ opserr( EFFTOK_EXPECTED, NULL ); ;
    break;}
case 9:
#line 105 "scan-ops.y"
{ opserr( EFFECTS_EXPECTED, NULL ); ;
    break;}
case 10:
#line 106 "scan-ops.y"
{ opserr( OPNAME_EXPECTED, NULL ); ;
    break;}
case 11:
#line 107 "scan-ops.y"
{
		      yyval.op_list = ( op_list ) malloc( sizeof( op_list_elt ) );
		      yyval.op_list->name = ( token ) calloc( 1 + strlen( yyvsp[-14].string ), sizeof( char ) );
		      strcpy( yyval.op_list->name, yyvsp[-14].string );
		      yyval.op_list->params = yyvsp[-10].fact_list;
		      yyval.op_list->preconds = yyvsp[-6].fact_list;
		      yyval.op_list->effects = yyvsp[-2].effect_list;
		      yyval.op_list->next = yyvsp[0].op_list;
		    ;
    break;}
case 12:
#line 120 "scan-ops.y"
{ yyval.fact_list = NULL; ;
    break;}
case 13:
#line 122 "scan-ops.y"
{
		      yyval.fact_list = yyvsp[-2].fact_list;
		      for( act_var=yyval.fact_list; act_var; act_var=act_var->next )
			{ /* adjust types (2nd element of token_list) for varlist */
			  act_var->item->next = 
			    ( token_list ) malloc( sizeof( token_list_elt ) );
			  act_var->item->next->item = 
			    ( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
			  strcpy( act_var->item->next->item, yyvsp[-1].string );
			  act_var->item->next->next = NULL;
			  if ( !act_var->next ) {
			    act_var->next = yyvsp[0].fact_list; 
			    break;
			  }
			}
		    ;
    break;}
case 14:
#line 141 "scan-ops.y"
{ yyval.fact_list = NULL; ;
    break;}
case 15:
#line 143 "scan-ops.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[-1].string );
		      yyval.fact_list->next = yyvsp[0].fact_list;
		    ;
    break;}
case 16:
#line 154 "scan-ops.y"
{ yyval.fact_list = NULL; ;
    break;}
case 17:
#line 156 "scan-ops.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 1 + strlen( yyvsp[-4].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, yyvsp[-4].string );
		      yyval.fact_list->item->next = yyvsp[-2].token_list;
		      yyval.fact_list->next = yyvsp[0].fact_list;
             	    ;
    break;}
case 18:
#line 166 "scan-ops.y"
{
		      yyval.fact_list = ( fact_list ) malloc( sizeof( fact_list_elt ) );
		      yyval.fact_list->item = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.fact_list->item->item = 
			( token ) calloc( 2 + strlen( yyvsp[-4].string ), sizeof( char ) );
		      strcpy( yyval.fact_list->item->item, "!" );
		      strcat( yyval.fact_list->item->item, yyvsp[-4].string );
		      yyval.fact_list->item->next = yyvsp[-2].token_list;
		      yyval.fact_list->next = yyvsp[0].fact_list;
		    ;
    break;}
case 19:
#line 179 "scan-ops.y"
{ yyval.token_list = NULL; ;
    break;}
case 20:
#line 181 "scan-ops.y"
{
		      yyval.token_list = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.token_list->item = ( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( yyval.token_list->item, yyvsp[-1].string );
		      yyval.token_list->next = yyvsp[0].token_list;
		    ;
    break;}
case 21:
#line 188 "scan-ops.y"
{
		      yyval.token_list = ( token_list ) malloc( sizeof( token_list_elt ) );
		      yyval.token_list->item = ( token ) calloc( 1 + strlen( yyvsp[-1].string ), sizeof( char ) );
		      strcpy( yyval.token_list->item, yyvsp[-1].string );
		      yyval.token_list->next = yyvsp[0].token_list;
		    ;
    break;}
case 22:
#line 201 "scan-ops.y"
{
		      yyval.effect_list = ( effect_list ) malloc( sizeof( effect_list_elt ) );
		      yyval.effect_list->quantified_variables = yyvsp[-5].fact_list;
		      yyval.effect_list->conditions = yyvsp[-4].fact_list;
		      yyval.effect_list->add_effects = yyvsp[-2].fact_list;
		      yyval.effect_list->del_effects = yyvsp[-1].fact_list;
		      yyval.effect_list->next = yyvsp[0].effect_list; /* NULL or another effect_list */
		    ;
    break;}
case 23:
#line 210 "scan-ops.y"
{
		      yyval.effect_list = ( effect_list ) malloc( sizeof( effect_list_elt ) );
		      yyval.effect_list->quantified_variables = NULL;
		      yyval.effect_list->conditions = yyvsp[-4].fact_list;
		      yyval.effect_list->add_effects = yyvsp[-2].fact_list;
		      yyval.effect_list->del_effects = yyvsp[-1].fact_list;
		      yyval.effect_list->next = yyvsp[0].effect_list; /* NULL or another effect_list */
		    ;
    break;}
case 24:
#line 221 "scan-ops.y"
{ yyval.fact_list = NULL; ;
    break;}
case 25:
#line 223 "scan-ops.y"
{ yyval.fact_list = yyvsp[0].fact_list; ;
    break;}
case 26:
#line 227 "scan-ops.y"
{ yyval.fact_list = NULL; ;
    break;}
case 27:
#line 229 "scan-ops.y"
{ yyval.fact_list = yyvsp[0].fact_list; ;
    break;}
case 28:
#line 233 "scan-ops.y"
{ yyval.effect_list = NULL; ;
    break;}
case 29:
#line 234 "scan-ops.y"
{ yyval.effect_list = yyvsp[0].effect_list; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 242 "scan-ops.y"


#include "lex.ops.c"

void opserr( int errno, char *par )
{
  act_err = errno;
  act_err_par = par;
}
  
int yyerror( char *msg )
{
  printf("%s: syntax error in line %d, '%s':\n", act_filename, lineno, yytext );
  if ( act_err_par )
    {
      printf( errmsg[act_err], act_err_par );
      printf( "\n" );
    }
  else
    printf("%s\n", errmsg[act_err] );
  exit( 1 );
}


void load_ops_file( char *filename )
{
  FILE *fp;/* pointer to input files */

  /* open operator file */
  if( ( fp = fopen( filename, "r" ) ) == NULL ) {
    printf( "\nipp: can't find operator file: %s\n\n", filename );
    exit( 1 );
  }
  act_filename = filename;
  lineno = 1; 
  yyin = fp;
  yyparse();
  fclose( fp );/* and close file again */
}


void print_ops( op_list op )
{
  
  op_list    i_op;
  effect_list  i_list;

  for ( i_op = op; i_op; i_op = i_op->next ) {
    
    printf( "\n%s \n", i_op->name );

    printf( "v: " );
    print_factlist( i_op->params );

    printf( "\np: ");
    print_factlist( i_op->preconds );

    printf( "\ne: ");
    for ( i_list = i_op->effects; i_list; i_list = i_list->next ) {
      if ( i_list->quantified_variables ) {
        printf( "ALL " );
        print_factlist( i_list->quantified_variables );
      }
      if ( i_list->conditions ) {
        print_factlist( i_list->conditions );
        printf( "=> " ); 
      }
      if ( i_list->add_effects ) {
        printf( "ADD " );
        print_factlist( i_list->add_effects );
        if ( i_list->del_effects ) {
          printf( "DEL " );
          print_factlist( i_list->del_effects );
          printf( ";\n" );
        } else {
          printf( ";\n" );
        }
      } else {
        printf( "DEL " );
        print_factlist( i_list->del_effects );
        printf( ";\n" );
      }
    }
  }
}

